package main

import (
	"flag"
	"fmt"
	"log"
	"strings"

	enumpb "gitlab.com/akordacorp/lab/protoc-gen-enum/enum"
	"google.golang.org/protobuf/compiler/protogen"
	"google.golang.org/protobuf/proto"
)

var (
	enumPrefix *string
)

func main() {

	var flags flag.FlagSet
	enumPrefix = flags.String("prefix", "com.akorda", "prefix for enum names")

	protogen.Options{
		ParamFunc: flags.Set,
	}.Run(func(gen *protogen.Plugin) error {
		for _, f := range gen.Files {
			if !f.Generate {
				continue
			}
			generate := false
			for _, enum := range f.Enums {
				if proto.GetExtension(enum.Desc.Options(), enumpb.E_EventName).(bool) {
					generate = true
					break
				}
			}
			if generate {
				generateFile(gen, f)
			}
		}
		return nil
	})
}

// generateFile generates a _enum.pb.golang file containing methods to get enum values.
func generateFile(gen *protogen.Plugin, file *protogen.File) *protogen.GeneratedFile {

	filename := file.GeneratedFilenamePrefix + "_enum.pb.go"
	g := gen.NewGeneratedFile(filename, file.GoImportPath)
	g.P("// Code generated by protoc-gen-go-enum. DO NOT EDIT.")
	g.P()
	g.P("// source: ", file.GeneratedFilenamePrefix+".proto")
	g.P("package ", file.GoPackageName)
	g.P()
	g.P("import (\n\t\"strings\"\n)\n")
	g.P()
	g.P("const (")
	g.P(fmt.Sprintf("enumPrefix = \"%s\"", *enumPrefix))
	g.P("eventSep   = \"_EVENT_\"")
	g.P(")")

	for _, enum := range file.Enums {

		if !proto.GetExtension(enum.Desc.Options(), enumpb.E_EventName).(bool) {
			continue
		}

		// Force the Enum name to end with "Event". Example: "DocumentEvent".
		if !strings.HasSuffix(strings.ToLower(enum.GoIdent.GoName), "event") {
			log.Fatal(fmt.Sprintf("Enum %s is not an event", enum.GoIdent.GoName))
		}

		// Force all enum values to start with the enum name.
		for _, enumVal := range enum.Values {
			split := strings.Split(enumVal.GoIdent.GoName, "_")
			val := strings.Join(split[1:], "")
			if !strings.HasPrefix(strings.ToLower(val), strings.ToLower(enum.GoIdent.GoName)) {
				log.Fatal(fmt.Sprintf("Enum value %s is not prefixed with %s", enumVal.GoIdent.GoName, enum.GoIdent.GoName))
			}
		}

		g.P("func (x ", enum.GoIdent, ") EventName() string {")
		g.P()
		g.P("split := strings.Split(x.String(), eventSep)")
		g.P()
		g.P("if len(split) <= 1 { // malforned enum value")
		g.P("return \"\"")
		g.P("}")
		g.P()
		g.P("var items []string")
		g.P("if enumPrefix != \"\" {")
		g.P("items = append(items, enumPrefix)")
		g.P("}")
		g.P()
		g.P("items = append(items, strings.ToLower(strings.Join(split[0:len(split)-1], \"_\"))) //resource name")
		g.P("items = append(items, strings.ToLower(split[len(split)-1])) //verb")
		g.P()
		g.P("return strings.Join(items, \".\")")
		g.P("}")
		g.P()
	}

	return g
}
